#!/usr/bin/env python

# Copyright (c) 2019, IRIS-HEP
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
# * Neither the name of the copyright holder nor the names of its
#   contributors may be used to endorse or promote products derived from
#   this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

from aghast.interface import frombuffer
from aghast.interface import fromarray
from aghast.interface import fromfile

def tonumpy(obj):
    import aghast._connect._numpy
    return aghast._connect._numpy.tonumpy(obj)

def fromnumpy(obj):
    import aghast._connect._numpy
    return aghast._connect._numpy.fromnumpy(obj)

def topandas(obj):
    import aghast._connect._pandas
    return aghast._connect._pandas.topandas(obj)

def frompandas(obj):
    import aghast._connect._pandas
    return aghast._connect._pandas.frompandas(obj)

def toroot(obj, name):
    import aghast._connect._root
    return aghast._connect._root.toroot(obj, name)

def fromroot(obj, collection=False):
    import aghast._connect._root
    return aghast._connect._root.fromroot(obj, collection=collection)

def tofnalhist(obj):
    import aghast._connect._fnalhist
    return aghast._connect._fnalhist.tofnalhist(obj)

def fromfnalhist(obj):
    import aghast._connect._fnalhist
    return aghast._connect._fnalhist.fromfnalhist(obj)

from aghast.interface import Metadata
from aghast.interface import Decoration
from aghast.interface import Buffer
from aghast.interface import ExternalBuffer
from aghast.interface import Interpretation
from aghast.interface import InterpretedBuffer
from aghast.interface import RawInlineBuffer
from aghast.interface import RawExternalBuffer
from aghast.interface import InterpretedInlineBuffer
from aghast.interface import InterpretedInlineInt64Buffer
from aghast.interface import InterpretedInlineFloat64Buffer
from aghast.interface import InterpretedExternalBuffer
from aghast.interface import StatisticFilter
from aghast.interface import Moments
from aghast.interface import Extremes
from aghast.interface import Quantiles
from aghast.interface import Modes
from aghast.interface import Statistics
from aghast.interface import Covariance
from aghast.interface import BinLocation
from aghast.interface import IntegerBinning
from aghast.interface import RealInterval
from aghast.interface import RealOverflow
from aghast.interface import RegularBinning
from aghast.interface import HexagonalBinning
from aghast.interface import EdgesBinning
from aghast.interface import IrregularBinning
from aghast.interface import CategoryBinning
from aghast.interface import SparseRegularBinning
from aghast.interface import FractionBinning
from aghast.interface import PredicateBinning
from aghast.interface import Assignment
from aghast.interface import Variation
from aghast.interface import VariationBinning
from aghast.interface import Axis
from aghast.interface import Profile
from aghast.interface import UnweightedCounts
from aghast.interface import WeightedCounts
from aghast.interface import Parameter
from aghast.interface import ParameterizedFunction
from aghast.interface import EvaluatedFunction
from aghast.interface import BinnedEvaluatedFunction
from aghast.interface import Histogram
from aghast.interface import Page
from aghast.interface import ColumnChunk
from aghast.interface import Chunk
from aghast.interface import Column
from aghast.interface import NtupleInstance
from aghast.interface import Ntuple
from aghast.interface import Collection
